module Ruboty
  module Handlers
    class LastWords < Base
      on /(?<keyword>.+)/, name: 'catchall', hidden: true, all: true
      on /(?<username>.+)'s last words$/, name: 'last_words', description: 'Refer last words'

      def catchall(message)
        words[message.from_name] = { body: message[:keyword], time: Time.new }
      end

      def last_words(message)
        if last_words = words[message[:username]]
          header = "#{message[:username]} said..."
          body = "#{last_words[:body]}\n[#{last_words[:time]}]"
          message.reply(header)
          message.reply(body, code: true)
        else
          message.reply("#{message[:username]} was forgotten...")
        end
      end

      private

      def words
        robot.brain.data[Ruboty::LastWords::NAMESPACE] ||= {}
      end
    end
  end
end
